package idi.alexanbj.em;

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class Topic {
	
	private static final String TOPICS_PATH = "/home/alexanbj/MEDLINE/queries2.xml";
	
	private String mID;
	private String mTitle;
	private String mInformationNeed;
	private String mContext;
	
	private static Topic[] instance = null;
	
	private Topic(String id, String title, String informationNeed, String context) {
		mID = id;
		mTitle = title;
		mInformationNeed = informationNeed;
		mContext = context;
	}
	
	@Override
	public String toString() {
		return mID + " " + mTitle;
	}
	
	public String getID() {
		return mID;
	}
	
	public String getTitle() {
		return mTitle;
	}
	
	public String getNeed() {
		return mInformationNeed;
	}
	
	public String getContext() {
		return mContext;
	}
	
	private static Topic[] parseTopics() {
		Topic[] topics = new Topic[50];
		
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		try {
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			Document doc = docBuilder.parse(TOPICS_PATH);
			
			
	
			Element root = doc.getDocumentElement();
			
			NodeList nl = root.getElementsByTagName("TOPIC");
	
			for (int i = 0; i < nl.getLength(); i++) {
				
				Element el = (Element) nl.item(i);
				
				NodeList idList = el.getElementsByTagName("ID");
				String id = idList.item(0).getChildNodes().item(0).getNodeValue().trim();
				idList = el.getElementsByTagName("TITLE");
				String title = idList.item(0).getChildNodes().item(0).getNodeValue().trim();
				idList = el.getElementsByTagName("NEED");
				String need = idList.item(0).getChildNodes().item(0).getNodeValue().trim();
				idList = el.getElementsByTagName("CONTEXT");
				String context = idList.item(0).getChildNodes().item(0).getNodeValue().trim();
				
				Topic t = new Topic(id, title, need, context);
				
				topics[i] = t;
			}
			
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return topics;
	}
	
	public static Topic[] getTopics() {
		if(instance == null) {
			instance = parseTopics();
		}
		return instance;
	}
}

